<?php 

// Extra for all platforms
//
// How to register an extra and the functions that it performs and when to perform them (at operation)
//
// $extra = array ( 'at operation' => 'extra function' );
//
$extra['autoimages'] = array (
	'name' => 'AutoImages',
	'description' => 'Replaces any default images with images from the theme automagically',
	'version' => '1.7',
	'author' => 'Shawn McKenzie',
	'contact' => 'http://spidean.mckenzies.net',
	'themepostprocess' => 'at_autoimages'
);

// Extra functions
//
function at_autoimages($display)
{
	preg_match_all("|\<img src=[\'\"]([^\'\"]+)[\'\"]|", $display, $images);
	
	foreach ($images[1] as $key => $path) {
		$parts = explode("/", $path);
		$last = count($parts) - 1;
		$new = "";
		
		 switch ($parts[0]) {
		 	case "modules":
		 		$new = atImageSearch2($parts[$last], $parts[1]);
		 		break;
		 		
		 	case "images":
			 	$new = atImageSearch2($parts[1]."/".$parts[$last]);
		 		break;		 		
		 }
		 if ($new) {
		 	$search[$key] = $path;
		 	$replace[$key] = $new;
		 }
	}
	$display = str_replace($search, $replace, $display);

	return $display;
}

// will merge with api atImageSearch() which is buggy
function atImageSearch2($path, $module=null)
{	
	$runningconfig = atGetRunningConfig();
	extract($runningconfig);
	
	$path = explode(".", $path);
	
	$types = array("jpg", "gif", "png");
	
	if (isset($module)) {
		$paths[] = $imagelangpath."modules/$module/".$path[0];
	    $paths[] = $imagepath."modules/$module/".$path[0];
	}
	else {
    	$paths[] = $imagelangpath.$path[0];
    	$paths[] = $imagepath.$path[0];
	}
	
	foreach ($types as $type) {
		foreach ($paths as $file) {
		    if (file_exists("$file.$type")) {
				return "$file.$type";
			}
		}		
	}
	return FALSE;	
}

?>
